`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2021/04/30 16:57:22
// Design Name: 
// Module Name: adder
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module adder(
    input key_valid,
    input [8:0] last_change,
    input [511:0] key_down,
    input rst,
    output [3:0] addend,
    output [3:0] augend,
    output reg [3:0] sum1,
    output reg [3:0] sum2
    );
    reg [3:0] number;
    reg [3:0] shifter3;
    reg [3:0] shifter2;
    reg [3:0] shifter1;
    reg [3:0] shifter0;
    wire [7:0] sum;
    wire [7:0] sum_tmp;
    
    always@*
    if(key_valid)
        case(last_change)
            9'h70: number = 4'b0000;
            9'h69: number = 4'b0001;
            9'h72: number = 4'b0010;
            9'h7A: number = 4'b0011;
            9'h6B: number = 4'b0100;
            9'h73: number = 4'b0101;
            9'h74: number = 4'b0110;
            9'h6C: number = 4'b0111;
            9'h75: number = 4'b1000;
            9'h7D: number = 4'b1001;
            default: number = 4'b0000;
        endcase
    else
        number = number;
    
    always@(posedge key_valid or posedge rst)
    if(rst || last_change == 9'h5A)
    begin
        shifter3 <= 4'b0000;
        shifter2 <= 4'b0000;
        shifter1 <= 4'b0000;
        shifter0 <= 4'b0000;
    end
    else
    begin
        shifter3 <= shifter2;
        shifter2 <= shifter1;
        shifter1 <= shifter0;
        shifter0 <= number;
    end
    
    assign addend = shifter2;
    assign augend = shifter0;
    assign sum = {4'b0000,shifter2} + {4'b0000,shifter0};
    assign sum_tmp = {4'b0000,shifter2} + {4'b0000,shifter0} - 8'b0000_1010;
    
    always@*
    if(sum > 8'b0000_1001)
    begin
        sum1 = sum_tmp[3:0];
        sum2 = 4'b0001;
    end
    else
    begin
        sum1 = sum[3:0];
        sum2 = 4'b0000;
    end
endmodule
