module scan_ctl(
    output reg [3:0] ssd_ctl,
    output reg [3:0] ssd_in,
    input clk,
    input rst,
    input [3:0] addend,
    input [3:0] augend,
    input [3:0] sum1,
    input [3:0] sum2
    );
    reg [10:0] cnt;
    reg [12:0] cnt_tmp;
    reg [1:0] scan_ctl;
    
    always@*
    cnt_tmp = {scan_ctl,cnt} + 1'b1;
    
    always@(posedge clk or posedge rst)
    if(rst)
        {scan_ctl,cnt} <= 13'd0;
    else
        {scan_ctl,cnt} <= cnt_tmp;
        
    always@*
    case(scan_ctl)
        2'b00:
        begin
            ssd_ctl = 4'b1110;
            ssd_in = sum1;
        end
        2'b01:
        begin
            ssd_ctl = 4'b1101;
            ssd_in = sum2;
        end
        2'b10:
        begin
            ssd_ctl = 4'b1011;
            ssd_in = augend;
        end
        2'b11:
        begin
            ssd_ctl = 4'b0111;
            ssd_in = addend;
        end
        default:
        begin
            ssd_ctl=4'b0000;
            ssd_in = sum1;
        end
    endcase
    
endmodule
