module top_module(
    input clk,
    input rst,
    inout PS2_DATA,
    inout PS2_CLK,
    output [3:0] ssd_ctl,
    output [7:0] segs
    );
    wire [8:0] last_change;
    wire [511:0] key_down;
    wire key_valid;
    wire [3:0] addend;
    wire [3:0] augend;
    wire [3:0] sum1;
    wire [3:0] sum2;
    wire [3:0] ssd_in;
        
    KeyboardDecoder U0(.clk(clk),.rst(rst),.PS2_DATA(PS2_DATA),.PS2_CLK(PS2_CLK)
                        ,.last_change(last_change),.key_down(key_down),.key_valid(key_valid));
    adder U1(.rst(rst),.last_change(last_change),.key_down(key_down),.key_valid(key_valid)
             ,.addend(addend),.augend(augend),.sum1(sum1),.sum2(sum2));
    scan_ctl U2(.clk(clk),.rst(rst),.addend(addend),.augend(augend),.sum1(sum1),.sum2(sum2),.ssd_in(ssd_in),.ssd_ctl(ssd_ctl));
    display U3(.i(ssd_in),.D(segs));
    
endmodule